"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const ansi_escapes_1 = require("ansi-escapes");
const chalk_1 = tslib_1.__importDefault(require("chalk"));
const ora_1 = tslib_1.__importDefault(require("ora"));
const ms_1 = tslib_1.__importDefault(require("ms"));
// This was copied from Razzle. Lots of unused stuff.
exports.info = msg => {
    console.log(`${chalk_1.default.gray('>')} ${msg}`);
};
exports.error = msg => {
    if (msg instanceof Error) {
        msg = msg.message;
    }
    console.error(`${chalk_1.default.red('> Error!')} ${msg}`);
};
exports.success = msg => {
    console.log(`${chalk_1.default.green('> Success!')} ${msg}`);
};
exports.time = () => {
    const start = new Date();
    return chalk_1.default.gray(`[${ms_1.default(new Date() - start)}]`);
};
exports.wait = msg => {
    const spinner = ora_1.default(chalk_1.default.green(msg));
    spinner.color = 'blue';
    spinner.start();
    return () => {
        spinner.stop();
        process.stdout.write(ansi_escapes_1.eraseLine);
    };
};
exports.prompt = opts => {
    return new Promise((resolve, reject) => {
        opts.forEach((val, i) => {
            const text = val[1];
            console.log(`${chalk_1.default.gray('>')} [${chalk_1.default.bold(i + 1)}] ${text}`);
        });
        const ondata = v => {
            const s = v.toString();
            function cleanup() {
                process.stdin.setRawMode(false);
                process.stdin.removeListener('data', ondata);
            }
            if (s === '\u0003') {
                cleanup();
                reject(new Error('Aborted'));
                return;
            }
            const n = Number(s);
            if (opts[n - 1]) {
                cleanup();
                resolve(opts[n - 1][0]);
            }
        };
        process.stdin.setRawMode(true);
        process.stdin.resume();
        process.stdin.on('data', ondata);
    });
};
exports.cmd = cmd => {
    return chalk_1.default.bold(chalk_1.default.cyan(cmd));
};
exports.code = cmd => {
    return `${chalk_1.default.gray('`')}${chalk_1.default.bold(cmd)}${chalk_1.default.gray('`')}`;
};
exports.param = param => {
    return chalk_1.default.bold(`${chalk_1.default.gray('{')}${chalk_1.default.bold(param)}${chalk_1.default.gray('}')}`);
};
